#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLMULTTRANSPOSEMATRIXDPROC glMultTransposeMatrixd;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 }; /* ʒu@@@ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ڌx */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* x */

/*
** }eA
*/
static const GLfloat kdiff[] = { 0.0, 0.1, 0.3, 1.0 };  /* gUˌW */
static const GLfloat kspec[] = { 0.6, 0.6, 0.6, 1.0 };  /* ʔˌW */
static const GLfloat knone[] = { 0.0, 0.0, 0.0, 1.0 };  /* ʔ˖ */
static const GLfloat kshi = 20.0;                       /* PW@@ */

/*
** eNX`
*/
#define TEXWIDTH  128                      /* eNX`̕@@@ */
#define TEXHEIGHT 128                      /* eNX`̍@@ */
static const char *textures[] = {          /* eNX`t@C */
  "room2nx.raw",
  "room2ny.raw",
  "room2nz.raw",
  "room2px.raw",
  "room2py.raw",
  "room2pz.raw",
};
static const int target[] = {           /* eNX`̃^[Qbg */
  GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
  GL_TEXTURE_CUBE_MAP_POSITIVE_X,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
};

/*
** ʔˌx
*/
static void specular(float fx, float fy, float fz, const float l[], GLubyte col[])
{
  /* xNgƔ˃xNg̓ς߂ */
  float lf = l[0] * fx + l[1] * fy + l[2] * fz;
  
  if (lf > 0.0) {
    /* ʔ˗~255߂ */
    float rs = pow(lf, kshi) * 255.0;
    
    /* ʔˌx߂ */
    col[0] = (GLubyte)(kspec[0] * rs * lightcol[0]);
    col[1] = (GLubyte)(kspec[1] * rs * lightcol[1]);
    col[2] = (GLubyte)(kspec[2] * rs * lightcol[2]);
  }
  else {
    col[0] = col[1] = col[2] = 0;
  }
}

/*
** eNX`̍쐬
*/
static void makeTexture(GLubyte *tex[], int width, int height)
{
  int i = 0;
  
  /* ˃xNgƌxNgƂ̓ϒlŃeNX` */
  for (int v = 0; v < height; ++v) {
    float y = (float)(v + v - height) / (float)height;
    float y2 = y * y;
    
    for (int u = 0; u < width; ++u) {
      float x = (float)(u + u - width) / (float)width;
      float x2 = x * x;

      /* ˃xNg */
      float r = 1.0 / sqrt(x2 + y2 + 1.0);
      float s = x * r;
      float t = y * r;
      
      /* Uʂ̃eNX`ɂĂꂼꋾʔˋx߂ */
      specular(-r, -t,  s, lightpos, tex[0] + i);  /* negative x */
      specular( s, -r, -t, lightpos, tex[1] + i);  /* negative y */
      specular(-s, -t, -r, lightpos, tex[2] + i);  /* negative z */
      specular( r, -t, -s, lightpos, tex[3] + i);  /* positive x */
      specular( s,  r,  t, lightpos, tex[4] + i);  /* positive y */
      specular( s, -t,  r, lightpos, tex[5] + i);  /* positive z */
      
      i += 3;
    }
  }
}

/*
** 
*/
static void init(void)
{
  /* eNX`̓ǂݍ݂Ɏgz */
  static GLubyte t[6][TEXHEIGHT * TEXWIDTH * 3];
  static GLubyte *texture[] = { t[0], t[1], t[2], t[3], t[4], t[5] };
  
  /* eNX`̍쐬 */
  makeTexture(texture, TEXWIDTH, TEXHEIGHT);
  
  /* eNX`摜̓oCgPʂɋlߍ܂Ă */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  
  for (int i = 0; i < 6; ++i) {
#if 0
    /* eNX`̓ǂݍ݂Ɏgz */
    GLubyte texture[TEXHEIGHT][TEXWIDTH][4];
    FILE *fp;
    
    /* eNX`摜̓ǂݍ */
    if ((fp = fopen(textures[i], "rb")) != NULL) {
      fread(texture, sizeof texture, 1, fp);
      fclose(fp);
    }
    else {
      perror(textures[i]);
    }
#endif
    
    /* eNX`̊蓖 */
    glTexImage2D(target[i], 0, GL_RGB, TEXWIDTH, TEXHEIGHT, 0,
      GL_RGB, GL_UNSIGNED_BYTE, texture[i]);
  }
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* eNX` */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);
  
  /* L[u}bsOp̃eNX`W𐶐*/
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  
  /* ݒ */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ̏ݒ */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
  
#if defined(WIN32)
  glMultTransposeMatrixd =
    (PFNGLMULTTRANSPOSEMATRIXDPROC)wglGetProcAddress("glMultTransposeMatrixd");
#endif
}

/* `֐̐錾 */
#include "box.h"

/*
** V[̕`
*/
static void scene(void)
{
#if 0
  static const GLfloat color[] = { 1.0, 1.0, 1.0, 1.0 };  /* ގ (F) */
#endif
  
  /* ގ̐ݒ */
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, kdiff);
  glMaterialfv(GL_FRONT, GL_SPECULAR, knone);
  
  /* eNX`}bsOJn */
  glEnable(GL_TEXTURE_CUBE_MAP);
  
  /* eNX`W̎Lɂ */
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  
#if 0
  /* ` */
  box(1.0, 1.0, 1.0);
#else
  /* eB[|bg` */
  glutSolidTeapot(1.0);
#endif
  
  /* eNX`W̎𖳌ɂ */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  
  /* eNX`}bsOI */
  glDisable(GL_TEXTURE_CUBE_MAP);
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

/* gbN{[p֐̐錾 */
#include "trackball.h"

static void display(void)
{
  /* eNX`ϊs̐ݒ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  
  /* gbN{[ɂ] */
  glMultTransposeMatrixd(trackballRotation());
  
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ̈ʒuݒ */
  glPushMatrix();
  glMultMatrixd(trackballRotation());
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  glPopMatrix();
  
  /* _̈ړî̕Ɉړj*/
  glTranslated(0.0, 0.0, -3.0);
  
#if 0
  /* gbN{[ɂ] */
  glMultMatrixd(trackballRotation());
#endif
  
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* V[̕` */
  scene();
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
